;--------------------------------------------------------------------
;find new message
;at command:	AT^SMGL=0
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

findnewmsg:	pollmode
		dispstrlcd1 txtfindnew
		dispstrlcd2 txtplswait
		sendatcmd txtatsmgl0
		mov a,#13
		call sendchar2gsm
		call waitsmgl
		jc smglparamtr
smglerror:	dispstrlcd2 txtnonewmsg
		call delay05s
		clr c
		ret
smglparamtr:	gsmuartrxpoll 20
		jnc smglerror
		mov tmp4,tmp5
		mov tmp5,a
		cjne a,#',',smglparamtr
		mov index,tmp4		;get index new message
		dispstrlcd2 txtfoundnew
		mov a,index
		call outcharlcd
		call delay1s
		setb c
		ret

waitsmgl:	pollmode
		gsmuartrxpoll 20
		jnc smglrto
		call rolltmpbuffer
checksmgl:	cjne a,#'L',waitsmgl+2
		mov a,tmp6
		cjne a,#'G',waitsmgl+2
		mov a,tmp5
		cjne a,#'M',waitsmgl+2
		mov a,tmp4
		cjne a,#'S',waitsmgl+2
		mov a,tmp3
		cjne a,#'^',waitsmgl+2
		setb c			;^SMGL detected
smglrto:	ret

txtatsmgl0:	db 'AT^SMGL=0',0
txtfindnew:	db 'Check NEW MSG...',0
txtnonewmsg:	db 'No new message  ',0
txtfoundnew:	db 'Found NEW MSG #',0


;--------------------------------------------------------------------
;send message from sms memory
;at command:	AT+CMSS
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

sendmsg:	pollmode
		dispstrlcd1 txtsending
		mov a,index
		call outcharlcd
		dispstrlcd2 txtplswait
		call delay05s
		sendatcmd txtatcmss
		mov a,index
		call uarttx
		mov a,#13
		call sendchar2gsm
		mov r7,#2		;waitlongok x times
sendmsg1:	call waitlongok
		jc $+6
		djnz r7,sendmsg1
		jnc errorsendmsg
		dispstrlcd2 txtsendmsgok
		call delay1s
		setb c
		ret
errorsendmsg:	dispstrlcd2 txterrsendmsg
		call delay1s
		clr c
		ret

txtatcmss:	db 'AT+CMSS=',0
txtsending:	db 'Sending msg  # ',0
txtsendmsgok:	db 'Sending msg OK  ',0
txterrsendmsg:	db '+CMSS ERROR...  ',0


;--------------------------------------------------------------------
;delete message from sms memory
;at command:	AT+CMGD
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

delmsg:		pollmode
		dispstrlcd1 txtdelete
		mov a,index
		call outcharlcd
		dispstrlcd2 txtplswait
		sendatcmd txtatcmgd
		mov a,index
		call uarttx
		mov a,#13
		call sendchar2gsm
		call waitok
		jnc errordelmsg
		dispstrlcd2 txtdelmsgok
		call delay1s
		setb c
		ret
errordelmsg:	dispstrlcd2 txterrdelmsg
		call delay1s
		clr c
		ret

txtatcmgd:	db 'AT+CMGD=',0
txtdelete:	db 'Delete msg    #',0
txtdelmsgok:	db 'Delete msg OK   ',0
txterrdelmsg:	db '+CMGD ERROR...  ',0


;--------------------------------------------------------------------
;get time from gsm
;at command:	AT+CCLK?
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

readtime:	clr flagprint
		call gettime
		setb flagprint
		ret

gettime:	pollmode
		dispstrlcd1 txtgettime
		dispstrlcd2 txtplswait
		sendatcmd txtatcclk
		mov a,#13
		call sendchar2gsm
		call waitcclk
		jc cclkparamtr
cclkerror:	dispstrlcd2 txtcclkerr
		clr c
		ret

cclkparamtr:	gsmuartrxpoll 20
		jnc cclkerror
		cjne a,#'"',cclkparamtr
		mov r7,#6
		mov r0,#tmp0
gettimehex:	call gethexgsm
		jnc cclkerror
		swap a			;swap cause print in swap (timestamp)
		mov @r0,a		;get time
		inc r0
		gsmuartrxpoll 20
		jnc cclkerror
		djnz r7,gettimehex
gettimehex1:	gsmuartrxpoll 20
		jnc cclkerror
		cjne a,#'K',gettimehex1
		call printtime
		setb c
		ret

printtime:	call line2
		mov a,tmp2
		call lcdswaphex		;printdate
		mov a,#'.'
		call outcharlcd
		mov a,tmp1
		call lcdswaphex		;printmonth
		mov a,#'.'
		call outcharlcd
		mov a,#'2'
		call outcharlcd
		mov a,#'0'
		call outcharlcd
		mov a,tmp0
		call lcdswaphex		;printyear
		mov a,#' '
		call outcharlcd
		mov a,tmp3
		call lcdswaphex		;printhour
		mov a,#':'
		call outcharlcd
		mov a,tmp4
		call lcdswaphex		;printminute
		ret

waitcclk:	pollmode
		gsmuartrxpoll 20
		jnc cclkrto
		call rolltmpbuffer
checkcclk:	cjne a,#'K',waitcclk+2
		mov a,tmp6
		cjne a,#'L',waitcclk+2
		mov a,tmp5
		cjne a,#'C',waitcclk+2
		mov a,tmp4
		cjne a,#'C',waitcclk+2
		mov a,tmp3
		cjne a,#'+',waitcclk+2
		setb c			;+CCLK detected
cclkrto:	ret

txtatcclk:	db 'AT+CCLK?',0
txtgettime:	db 'Get GSM time... ',0
txtcclkerr:	db '+CCLK ERROR     ',0


;--------------------------------------------------------------------
;read gsm battery
;at command:	AT+CBC
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

readgsmbatt:	clr flagprint
		call getgsmbatt
		setb flagprint
		ret

getgsmbatt:	pollmode
		dispstrlcd1 txtgsmbattery
		dispstrlcd2 txtplswait
		sendatcmd txtatcbc
		mov a,#13
		call sendchar2gsm
		call waitcbc
		jc cbcparamtr
cbcerror:	dispstrlcd2 txtcbcerr
		clr c
		ret

cbcparamtr:	gsmuartrxpoll 20
		jnc cbcerror
		cjne a,#',',cbcparamtr
		call wait3digit
		call conv3d2byte	;get gsm battery level
		call printbatt
		setb c
		ret

printbatt:	push acc
		dispstrlcd2 txtbatlevel
		call print3declcd
		mov a,#'%'
		call outcharlcd
		pop acc
		ret

waitcbc:	pollmode
		gsmuartrxpoll 20
		jnc cbcrto
		call rolltmpbuffer
checkcbc:	cjne a,#'C',waitcbc+2
		mov a,tmp6
		cjne a,#'B',waitcbc+2
		mov a,tmp5
		cjne a,#'C',waitcbc+2
		mov a,tmp4
		cjne a,#'+',waitcbc+2
		setb c			;+CBC detected
cbcrto:		ret

txtgsmbattery:	db 'Read GSM Batt...',0
txtatcbc:	db 'AT+CBC',0
txtbatlevel:	db 'BattLevel : ',0
txtcbcerr:	db '+CBC ERROR...   ',0


;--------------------------------------------------------------------
;read and load message
;at command:	AT^SMGR
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

loadmsg:	pollmode
		dispstrlcd1 txtblank
		dispstrlcd1 txtloadmsg
		mov a,index
		call outcharlcd
		dispstrlcd2 txtblank
		sendatcmd txtatsmgr
		mov a,index
		call uarttx
		mov a,#13
		call sendchar2gsm
		call waitsmgr
		jnc smgrerror

smgrparamtr:	gsmuartrxpoll 20
		jnc smgrerror
		mov tmp4,tmp5
		mov tmp5,a
		cjne a,#',',smgrparamtr
		mov status,tmp4		;get message status
		call wait3digit
		call conv3d2byte	;get pdu length
		mov lengthpdu,a
		jnz memnotempty
		dispstrlcd2 txtnomsg
		ret

memnotempty:	gsmuartrxpoll 20
		jnc smgrerror
		cjne a,#10,smgrerror
		call getmsgdata
		jnc smgrerror
		call decodemsg		;message read and decoded
		dispstrlcd2 txtsmgrok
		setb c
		ret
smgrerror:	dispstrlcd2 txtsmgrerr
		call delay05s
		clr c
		ret

getmsgdata:	mov r0,#bufferbase
		call gethexgsm
		jc $+8
		cjne a,#13,smgrerror
		jmp endmsgdata
		mov @r0,a
		inc r0
		jmp getmsgdata+2
endmsgdata:	mov @r0,#0		;terminate
		call waitok
		jnc smgrerror
		setb c
		ret

decodemsg:	call arrangepdu
		mov a,r1
		mov r0,a
		mov a,@r0		;sc number
		inc r0
		jz noscnbr
		mov r4,a
		inc r0
		djnz r4,$-1
noscnbr:	mov a,@r0		;msgtype
		inc r0
		jnb acc.0,msgdeliver
msgsubmit:	mov a,@r0		;msgref
		inc r0
		mov a,@r0		;dalength
		inc r0
		mov dalength,a
		jnz $+6
		inc r0
		jmp nodaaddr
		mov r4,a
		call getdaaddr
nodaaddr:	mov a,@r0		;pid
		inc r0
		mov a,@r0		;dcs
		inc r0
		mov a,@r0		;vp
		inc r0
		jmp udlandmsg
msgdeliver:	mov a,@r0		;oalength
		inc r0
		mov dalength,a
		jnz $+6
		inc r0
		jmp nooaaddr
		mov r4,a
		call getoaaddr
nooaaddr:	mov a,@r0		;pid
		inc r0
		mov a,@r0		;dcs
		inc r0
		mov r4,#7
getscts:	mov a,@r0		;scts
		inc r0
		djnz r4,getscts

udlandmsg:	mov a,@r0		;udl
		inc r0
		mov lengthascii,a
		jnz $+3
		ret
		call arrangeud
		call pdu2ascii
		call printcrlf
		call printbuffascii
		ret

arrangepdu:	mov r1,#0ffh
		dec r0
		mov a,@r0
		dec r0
		mov @r1,a
		dec r1
		cjne r0,#bufferbase-1,arrangepdu+3
		inc r1			;now, r1 as pdubuffbase
		ret

arrangeud:	push lengthascii
		mov r1,#bufferbase
		mov r4,#7
arrangeud1:	mov a,@r0
		inc r0
		mov @r1,a
		inc r1
		djnz r4,arrangeud2
		mov r4,#7
		mov @r1,#' '		;skip
		inc r1
		dec lengthascii
		mov a,lengthascii
		jz $+5
arrangeud2:	djnz lengthascii,arrangeud1
		pop lengthascii
		ret

getdaaddr:
getoaaddr:	call printcrlf
		mov a,@r0		;addr type
		inc r0
		mov a,r4
		inc a
		clr c
		rrc a
		mov r4,a
		mov r1,#buffbaseda
getaddr1:	mov a,@r0
		inc r0
		mov @r1,a
		inc r1
		push acc
		anl a,#0fh		;lower nibble first
		call htoa		;in swap byte
		call sendchar2pc
		pop acc
		anl a,#0f0h		;then higher nibble
		swap a
		call htoa
		cjne a,#'F',$+6
		jmp $+6
		call sendchar2pc
		djnz r4,getaddr1
		ret

waitsmgr:	pollmode
		gsmuartrxpoll 20
		jnc smgrrto
		call rolltmpbuffer
checksmgr:	cjne a,#'R',waitsmgr+2
		mov a,tmp6
		cjne a,#'G',waitsmgr+2
		mov a,tmp5
		cjne a,#'M',waitsmgr+2
		mov a,tmp4
		cjne a,#'S',waitsmgr+2
		mov a,tmp3
		cjne a,#'^',waitsmgr+2
		setb c			;^SMGR detected
smgrrto:	ret

txtatsmgr:	db 'AT^SMGR=',0
txtloadmsg:	db 'Load message  #',0
txtsmgrok:	db 'Load msg OK     ',0
txtnomsg:	db 'No message      ',0
txtsmgrerr:	db '^SMGR ERROR     ',0

;printmsgdump:	mov r0,#bufferbase
;		mov a,@r0
;		inc r0
;		mov var1,a
;		jz printpdudump-3
;		call sendhex2pc
;		mov a,@r0
;		inc r0
;		call sendhex2pc
;		djnz var1,$-5
;		jmp $+6
;		call sendhex2pc
;printpdudump:	push lengthpdu
;		mov a,@r0
;		inc r0
;		call sendhex2pc
;		djnz lengthpdu,printpdudump+2
;		pop lengthpdu
;		ret


;--------------------------------------------------------------------
;write message
;at command:	AT+CMGW
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

setdest:	mov dptr,#startdatafile
		call rdeeprom
		inc dptr
		jz skippin
		inc a
		clr c
		rrc a
		add a,dpl
		mov dpl,a
skippin:	call rdeeprom
		inc dptr
		jz skiporg
		inc a
		clr c
		rrc a
		add a,dpl
		mov dpl,a
skiporg:	call rdeeprom
		inc dptr
		mov dalength,a		;get dalength
		jnz $+3
		ret			;dalength=0
setdest2:	inc a
		clr c
		rrc a
		mov r4,a
		mov r0,#buffbaseda
setdest3:	call rdeeprom
		inc dptr
		mov @r0,a
		inc r0
		djnz r4,setdest3
		ret


writemsg:	dispstrlcd1 txtwritemsg
		dispstrlcd2 txtplswait
		call setdest		;destination addr
		sendatcmd txtatcmgw
		call cntlenpdutext
		call senddec2gsm
		mov a,#13
		call sendchar2gsm
		call delay1s
		mov a,#0		;smsc information
		call sendhex2gsm
		mov a,#11h		;1st octet sms submit, vp+mti
		call sendhex2gsm
		mov a,#0		;message ref
		call sendhex2gsm
		mov a,dalength		;da length
		call sendhex2gsm
		mov a,dalength
		jnz $+7
		mov a,#81h		;da = 0, unknown da
		jmp $+5
		mov a,#91h		;da /= 0, international number
		call sendhex2gsm
		mov a,dalength		;50h = dalength
		jz nodestaddr
		inc a
		clr c
		rrc a
		mov r7,a
		mov r0,#buffbaseda
sendnextda:	mov a,@r0		;dest address
		inc r0
		call sendhex2gsm
		djnz r7,sendnextda
nodestaddr:	mov a,#0		;tp pid
		call sendhex2gsm
		mov a,#0		;tp dcs
		call sendhex2gsm
		mov a,#2fh		;vp = 4 hours
		call sendhex2gsm
		mov a,lengthascii	;udl
		call sendhex2gsm
		mov a,lengthascii
		jz $+8
		call ascii2pdu
		call sendbuffpdu
		call delay100ms
		mov a,#26
		call sendchar2gsm

		call waitcmgw
		jnc errorwritemsg
		call wait3digit
		mov index,tmp2		;index memory
		dispstrlcd2 txtwritemsgok
		mov a,index
		call outcharlcd
		call delay1s
		setb c
		ret
errorwritemsg:	dispstrlcd2 txtcmgwerr
		call delay1s
		clr c
		ret

cntlenpdutext:	mov a,dalength		;50h = dalength
		inc a
		clr c
		rrc a
		add a,#8		;pdu head
		push acc
		mov a,lengthascii
		mov b,#8
		div ab
		mov b,a
		mov a,lengthascii
		clr c
		subb a,b
		mov b,a
		pop acc
		add a,b			;now, acc = lengthpdutext
		ret

sendbuffpdu:	push lengthascii
		mov r0,#buffbaseascii
		mov lengthpdu,#0
		mov shiftcounter,#8
		mov a,@r0
		inc r0
		djnz shiftcounter,$+9
		mov shiftcounter,#8
		jmp $+8
		call sendhex2gsm
		inc lengthpdu
		djnz lengthascii,sendbuffpdu+10
		pop lengthascii
		ret

waitcmgw:	pollmode
		gsmuartrxpoll 40
		jnc cmgwrto
		call rolltmpbuffer
checkcmgw:	cjne a,#'W',waitcmgw+2
		mov a,tmp6
		cjne a,#'G',waitcmgw+2
		mov a,tmp5
		cjne a,#'M',waitcmgw+2
		mov a,tmp4
		cjne a,#'C',waitcmgw+2
		mov a,tmp3
		cjne a,#'+',waitcmgw+2
		setb c			;+CMGW detected
cmgwrto:	ret

txtatcmgw:	db 'AT+CMGW=',0
txtwritemsg:	db 'Write message   ',0
txtwritemsgok:	db 'Write msg OK  #',0
txtcmgwerr:	db '+CMGW ERROR...  ',0