;--------------------------------------------------------------------
;delay function
;memory used:	r4, r5, r6
;--------------------------------------------------------------------

delay3s:	mov r6,#22
		mov r5,#24
		mov r4,#206
		djnz r4,$
		djnz r5,$-2
		djnz r6,$-4
		ret

delay2s:	mov r6,#15
		mov r5,#16
		mov r4,#221
		djnz r4,$
		djnz r5,$-2
		djnz r6,$-4
		ret

delay1s:	mov r6,#8
		mov r5,#8
		mov r4,#236
		djnz r4,$
		djnz r5,$-2
		djnz r6,$-4
		ret

delay05s:	mov r6,#4
		mov r5,#132
		mov r4,#116
		djnz r4,$
		djnz r5,$-2
		djnz r6,$-4
		ret

delay250ms:	mov r6,#2
		mov r5,#194
		mov r4,#56
		djnz r4,$
		djnz r5,$-2
		djnz r6,$-4
		ret

delay100ms:	mov r5,#180
		mov r4,#72
		djnz r4,$
		djnz r5,$-2
		nop
		ret

delay10ms:	mov r5,#18
		mov r4,#234
		djnz r4,$
		djnz r5,$-2
		ret


;--------------------------------------------------------------------
;lcd routine
;--------------------------------------------------------------------

busy:		mov r4,#20
		djnz r4,$
		ret

writefunc:	clr rs
		jmp $+5
writedata:	setb rs
		setb keyen
		push b
		anl a,#0fh
		mov b,a
		mov a,lcd
		anl a,#0f0h
		orl a,b
		mov lcd,a
		jnb flagprint,$+7	;don't print
		setb enlcd
		clr enlcd
		pop b
		orl lcd,#0fh
		clr keyen
		ret

initlcd:	clr rs
		clr enlcd
		call delay10ms
		mov a,#02h
		call writefunc
		call delay10ms
		call delay10ms
		mov a,#02h
		call writefunc
		call busy
		mov a,#02h
		call writefunc
		call busy
		mov a,#02h
		call writefunc
		mov a,#08h
		call writefunc
		call busy
		mov a,#00h
		call writefunc
		mov a,#01h
		call writefunc
		call delay10ms
		call busy
		mov a,#00h
		call writefunc
		mov a,#06h
		call writefunc
		call busy
		mov a,#00h
		call writefunc
		mov a,#0ch
		call writefunc
		ret

line1:		push acc
		mov a,#08h
		jmp $+7
line2:		push acc
		mov a,#0ch
		call busy
		call writefunc
		mov a,#00h
		call writefunc
		pop acc
		ret

outcharlcd:	call busy
		push acc
		swap a
		call writedata
		pop acc
		call writedata
		ret

outstrlcd:	push acc
		clr a
		movc a,@a+dptr
		jnz $+5
		pop acc
		ret
		call outcharlcd
		inc dptr
		jmp outstrlcd+2

strline1:	call line1
		call outstrlcd
		ret

strline2:	call line2
		call outstrlcd
		ret

print3declcd:	push acc
		mov b,#100
		div ab
		jz declcdunder100
declcdup100:	add a,#'0'
		call outcharlcd
		mov a,b
		mov b,#10
		div ab
declcdup10:	add a,#'0'
		jmp $+5
declcdunder10:	mov a,#' '
		call outcharlcd
		mov a,b
		add a,#'0'
		call outcharlcd
		pop acc
		ret
declcdunder100:	mov a,#' '
		call outcharlcd
		mov a,b
		mov b,#10
		div ab
		jz declcdunder10
		jmp declcdup10

lcdswaphex:	push acc
		push acc
		anl a,#0fh		;lower nibble first
		call htoa		;in swap byte
		call outcharlcd
		pop acc
		anl a,#0f0h		;then higher nibble
		swap a
		call htoa
		call outcharlcd
		pop acc
		ret