;--------------------------------------------------------------------
;16 bit addr eeprom routine
;memory used:	dph, dpl
;--------------------------------------------------------------------

ctrlbytewr	equ 10100000b
ctrlbyterd	equ 10100001b

;startbit i2c signal
startbit:	setb sdae
		setb sclke
		clr sdae
		mov r7,#2
		djnz r7,$
		clr sclke
		ret

;stopbit i2c signal
stopbit:	clr sdae
		setb sclke
		mov r7,#2
		djnz r7,$
		setb sdae
		clr sclke
		ret

;acknowledge and no ack i2c signal
ack:		clr sdae
		sjmp makeack
noack:		setb sdae
makeack:	nop
		setb sclke
		mov r7,#5
		djnz r7,$
		clr sclke
		ret

;send 1 byte data and receive acknowledge
i2csend:	mov r6,#8
i2csendloop:	rlc a
		mov sdae,c
		setb sclke
		mov r7,#5
		djnz r7,$
		clr sclke
		djnz r6,i2csendloop
		setb sdae
		setb sclke
		mov r7,#5
		djnz r7,$
		clr sclke
		ret

;receive 1 byte data
i2cget:		setb sdae
		mov r6,#8
i2cgetloop:	mov r7,#5
		djnz r7,$
		setb sclke
		mov c,sdae
		rlc a
		clr sclke
		djnz r6,i2cgetloop
		ret

wreeprom:	push acc
		call startbit
		mov a,#ctrlbytewr
		call i2csend
		mov a,dph
		call i2csend		;write high address
		mov a,dpl
		call i2csend		;write low address
		pop acc
		call i2csend		;write data
		call stopbit
		call delay10ms
		ret


rdeeprom:	call startbit
		mov a,#ctrlbytewr
		call i2csend
		mov a,dph
		call i2csend		;write high address
		mov a,dpl
		call i2csend		;write low address
		call startbit
		mov a,#ctrlbyterd
		call i2csend
		call i2cget		;read data
		call noack
		call stopbit
		ret

initdatafile:	mov dptr,#startdatafile
		mov var4,#10
nextdatafile:	clr a
		call wreeprom
		inc dptr
		djnz var4,nextdatafile
		ret

initpgmfile:	mov dptr,#startpgmfile
		jmp nextdatafile-3