;--------------------------------------------------------------------
;execute message after load it
;memory used:	
;--------------------------------------------------------------------

exemsg:		dispstrlcd1 txtexemsg
		mov a,index
		call outcharlcd
		dispstrlcd2 txtplswait
		clr flagprint
		call loadmsg
		setb flagprint
		jnc exemsgerr
		mov a,lengthpdu
		jnz exemsg1
		dispstrlcd2 txtnomsg
		jmp cmdnotexe
exemsg1:	mov a,lengthascii
		jz cmdnotexe
		call bufftolower
		call printbuffascii

msgdata:	call exectrldata
		jnc msgpgm
		setb c
		ret

msgpgm:		call exectrlpgm
		jnc msgstate
		setb c
		ret

msgstate:	call exerestatecmd
		jnc msgset
		setb c
		ret

msgset:		call exesetcmd
		jnc cmdnotexe
		ret

cmdnotexe:	dispstrlcd2 txtnotexe
		clr c
		ret

exemsgerr:	dispstrlcd2 txtexeerr
		clr c
		ret

txtexemsg:	db 'LOAD+EXE MSG  #',0
txtnotexe:	db 'NOT EXECUTE     ',0
txtexeerr:	db 'Error LOAD+EXE  ',0


;--------------------------------------------------------------------
;execute basic input output from message
;memory used:	
;format:	ctrlset
;		out=xxxx.xxxx		;set output port directly
;		o1=0 o2=1 o8=t		;set pin 0=off 1=on t=toggle
;		all random, all on, all off
;--------------------------------------------------------------------

exeallrandom:	call search
		jb flagfind,$+4
		ret
		mov outport,tl1
		setb flagexe
		ret

exealltoggle:	call search
		jb flagfind,$+4
		ret
		mov a,outport
		cpl a
		mov outport,a
		setb flagexe
		ret

exealloff:	call search
		jb flagfind,$+4
		ret
		mov outport,#0
		setb flagexe
		ret

exeallon:	call search		;format out=0000.0000
		jb flagfind,$+4
		ret
		mov outport,#0ffh
		setb flagexe
		ret

exeport:	call search
		jb flagfind,$+4
		ret
		mov r1,tmp2
		mov switch,#01h
		mov r7,#8
nextswitch:	mov a,@r0
		inc r0
		jnz $+3
		ret
		cjne a,#' ',$+5		;ignore space
		jmp nextswitch
		cjne a,#'.',$+5		;ignore dot
		jmp nextswitch
		call exeswtoggle
		mov a,switch
		clr c
		rlc a
		mov switch,a
		djnz r7,nextswitch
		ret

exeswitch:	call search
		jb flagfind,$+4
		ret
		clr a
		movc a,@a+dptr
		inc dptr
		djnz acc,$-1
		inc dptr
		movc a,@a+dptr
		mov switch,a		;find switch selected
		mov a,@r0
		inc r0
		cjne a,#' ',$+5
		jmp $-5
		mov r1,tmp2
exeswtoggle:	cjne a,#'t',exeswoff	;0xx=t
		mov a,@r1
		anl a,switch
		jz exeswon+3
		jmp $+6
exeswoff:	cjne a,#'0',exeswon	;oxx=0
		mov a,switch
		cpl a
		anl a,@r1		;switch off
		mov @r1,a
		setb flagexe
		ret
exeswon:	cjne a,#'1',$+9		;0xx=1
		mov a,switch
		orl a,@r1		;switch on
		mov @r1,a
		setb flagexe
		ret

;---------------
exesetcmd:	mov dptr,#txtctrlset
		call search
		jb flagfind,$+5
setnotexe:	clr c
		ret

		cjne r0,#bufferbase+8,$+3
		jnc setnotexe
		dispstrlcd2 txtmsgset
		call exeoutput
		jnb flagexe,setnotexe
setcmdexe:	setb c
		ret

exeoutput:	clr flagexe
		mov tmp2,#outport
		mov dptr,#txtoutport
		call exeport

		mov tmp2,#outport
		mov dptr,#txtout1
		call exeswitch
		mov dptr,#txtout2
		call exeswitch
		mov dptr,#txtout3
		call exeswitch
		mov dptr,#txtout4
		call exeswitch
		mov dptr,#txtout5
		call exeswitch
		mov dptr,#txtout6
		call exeswitch
		mov dptr,#txtout7
		call exeswitch
		mov dptr,#txtout8
		call exeswitch

		mov dptr,#txtallrandom
		call exeallrandom
		mov dptr,#txtalltoggle
		call exealltoggle
		mov dptr,#txtalloff
		call exealloff
		mov dptr,#txtallon
		call exeallon
		ret

txtmsgset:	db 'Message SET PORT',0
txtctrlset:	db 7,'ctrlset'
txtallrandom:	db 9,'allrandom'
txtalltoggle:	db 9,'alltoggle'
txtalloff:	db 6,'alloff'
txtallon:	db 5,'allon'
txtoutport:	db 4,'out='
txtout1:	db 3,'o1=',node1
txtout2:	db 3,'o2=',node2
txtout3:	db 3,'o3=',node3
txtout4:	db 3,'o4=',node4
txtout5:	db 3,'o5=',node5
txtout6:	db 3,'o6=',node6
txtout7:	db 3,'o7=',node7
txtout8:	db 3,'o8=',node8


;--------------------------------------------------------------------
;load data from message
;memory used:	
;format:	CTRLDataXXXX		;keyword+devicecode
;		P=2352			;pin
;		D=+6281xxx		;destination
;		O=+6281xxx		;originator
;--------------------------------------------------------------------

getpin:
getaddr:	mov dalength,#0
		mov a,@r0
		inc r0
		cjne a,#'+',$+5
		jmp $-5
		call isdigit
		jnc getaddreven
		call atoh
		swap a
		mov b,a
		inc dalength
		mov a,@r0
		inc r0
		call isdigit
		jnc getaddrodd
		call atoh
		orl a,b
		inc dalength
		swap a
		mov @r1,a
		inc r1
		jmp getaddr+3
getaddrodd:	mov a,#'F'
		call atoh
		orl a,b
		swap a
		mov @r1,a
		inc r1
getaddreven:	ret

getstrbuff:	mov dalength,#0
		mov a,@r0
		inc r0
		cjne a,#' ',$+5
		jmp $-5
		call isgraphic
		jnc endgetstr
		inc dalength
		mov @r1,a
		inc r1
		jmp getstrbuff+3
endgetstr:	ret

wrsubdatalen:	inc a
		clr c
		rrc a
		mov var4,a
		push 1h			;save r1
		dec r1
		djnz var4,$-1
		dec r1
		mov @r1,dalength
		pop 1h
		mov var4,r1
		ret

findsubdalen:	mov a,@r1		;find next subdata length
		inc a
		clr c
		rrc a
		push acc
		add a,b
		mov b,a
		pop acc
		mov var4,a
		jz $+6
		inc r1
		djnz var4,$-1
		inc r1
		ret

savedata:	push var4		;save file data to eeprom
		mov r0,#bufferbase
		mov dptr,#startdatafile
		mov a,@r0
		call wreeprom
		inc r0
		inc dptr
		djnz var4,savedata+7
		pop var4
		ret

printdatadump:	push var4		;print file data from eeprom
		mov dptr,#startdatafile
		call rdeeprom
		inc dptr
		call sendhex2pc
		djnz var4,printdatadump+5
		pop var4
		ret

loaddata:
loadpin:	mov dptr,#txtpin
		call search
		jnb flagfind,nodatapin
		mov r1,#bufferbase
		inc r1			;skip for pinlength
		call getpin
		mov a,dalength
		jz nodatapin
		call wrsubdatalen
		jmp loadorg

nodatapin:	mov r1,#bufferbase
		mov @r1,#0
		mov var4,#bufferbase+1

loadorg:	mov dptr,#txtorg
		call search
		jnb flagfind,nodataorg
		mov r1,var4		;next data start at var4
		inc r1			;skip for orglength
		call getaddr
		mov a,dalength
		jz nodataorg
		call wrsubdatalen
		jmp loaddest

nodataorg:	mov r1,var4
		mov @r1,#0
		inc r1
		mov var4,r1

loaddest:	mov dptr,#txtdest
		call search
		jnb flagfind,nodatadest
		mov r1,var4		;next data start at var4
		inc r1			;skip for destlength
		call getaddr
		mov a,dalength
		jz nodatadest
		call wrsubdatalen
		jmp exitloaddata

nodatadest:	mov r1,var4
		mov @r1,#0

exitloaddata:	mov r1,#bufferbase
		mov b,#0
		call findsubdalen
		call findsubdalen
		mov a,@r1		;find next subdata length
		inc a
		clr c
		rrc a
		add a,b
		add a,#3		;3 subdata
		mov var4,a		;var4=length ctrldata

		call savedata
		call printcrlf
		mov a,var4
		call sendhex2pc
		call printdatadump
		setb c
		ret

;---------------
exectrldata:	mov dptr,#txtctrldata
		call search
		jb flagfind,$+5
datanotexe:	clr c
		ret

		cjne a,#bufferbase+9,$+3
		jnc datanotexe
		dispstrlcd2 txtmsgdata
		call loaddata
		jnc datanotexe
		ret

txtmsgdata:	db 'Message DATA    ',0
txtctrldata:	db 8,'ctrldata'
txtpin:		db 2,'p='
txtdest:	db 2,'d='
txtorg:		db 2,'o='


;--------------------------------------------------------------------
;load timer program from message
;memory used:	
;format:	CTRLPgm2352		;keyword+pin
;		#251900*10001000	;#datetime*8bitport (1..8)
;		#252030*01110010
;		#252031*10110000
;		#260600*10001000
;		#260800*00001111
;		#262300*10100100
;		#262331*10000011
;		#270600*11001110
;		#00			;#00 end of program
;--------------------------------------------------------------------

exectrlpgm:	mov dptr,#txtctrlpgm
		call search
		jb flagfind,$+5
pgmnotexe:	clr c
		ret

		cjne r0,#bufferbase+8,$+3
		jnc pgmnotexe
		dispstrlcd2 txtmsgpgm
		call delay05s
		call loadpgm
		jnc pgmnotexe
		ret

loadpgm:	mov r1,#bufferbase
		mov var4,#0
		mov a,@r0
		inc r0
		jz loadpgmerr
		cjne a,#'#',$-4
loadpgmtime:	call gethexbuff
		jnc loadpgmerr
		jz loadpgmok		;if found zero, end of pgm
		mov @r1,a
		inc r1			;loading date
		inc var4
		call gethexbuff
		jnc loadpgmerr
		mov @r1,a
		inc r1			;loading hour
		inc var4
		call gethexbuff
		jnc loadpgmerr
		mov @r1,a
		inc r1			;loading minute
		inc var4

		mov r7,#8
loadpgmio:	mov a,@r0
		inc r0
		cjne a,#'#',$+5
		jmp loadpgmtime
		cjne a,#'*',$+5
		jmp loadpgmio
		cjne a,#'0',$+7
		clr c
		jmp $+4
		setb c
		mov a,b
		rrc a
		mov b,a
		djnz r7,loadpgmio
		mov a,b
		mov @r1,a
		inc r1
		inc var4
		jmp loadpgm+5

loadpgmok:	mov @r1,#0
		inc var4		;end of file program
		mov a,var4
		cjne a,#1,loadedpgm
loadpgmerr:	mov @r1,#0
		dispstrlcd2 txtpgmloaderr
		call delay1s
		clr c
		ret
loadedpgm:	dispstrlcd2 txtpgmloaded
		call savepgm
		call printpgmdump
		call readpgmdump
		setb c
		ret


savepgm:	push var4		;save file program to eeprom
		mov r0,#bufferbase
		mov dptr,#startpgmfile
		mov a,@r0
		call wreeprom
		inc r0
		inc dptr
		djnz var4,savepgm+7
		pop var4
		ret

printpgmdump:	push var4		;print file program from eeprom
		mov dptr,#startpgmfile
		call rdeeprom
		inc dptr
		call sendhex2pc
		djnz var4,printpgmdump+5
		pop var4
		ret

;read file program for checking
readpgmdump:	dispstrosd txtpgmio
		mov dptr,#startpgmfile
		call rdeeprom
		inc dptr
		jnz pgmdump
		dispstrosd txtendfile
		ret

pgmdump:	call sendhex2pc		;send day
		mov a,#' '
		call sendchar2pc
		call rdeeprom
		inc dptr
		call sendhex2pc		;send hour
		mov a,#':'
		call sendchar2pc
		call rdeeprom
		inc dptr
		call sendhex2pc		;send minute
		mov a,#' '
		call sendchar2pc
		call sendchar2pc
		mov a,#':'
		call sendchar2pc
		call rdeeprom
		inc dptr
		mov r7,#8
readpgmio:	rrc a
		mov b,a
		mov a,#' '
		call sendchar2pc
		jc sendon
		mov a,#'-'
		jmp $+5
sendon:		mov a,#'*'
		call sendchar2pc
		mov a,b
		djnz r7,readpgmio
		call printcrlf
		jmp readpgmdump+9


txtmsgpgm:	db 'Message PROGRAM ',0
txtctrlpgm:	db 7,'ctrlpgm'
txtpgmloaded:	db 'PROGRAM LOADED  ',0
txtpgmloaderr:	db 'PGM LOADING ERR ',0
txtpgmio:	db 13,10,'Programmable OUTPUT [1..8] :',13,10,0
txtendfile:	db 'PgmFile END',0


;--------------------------------------------------------------------
;execute state request message
;memory used:	
;format:	ctrlstate
;--------------------------------------------------------------------

wrrequest:	mov r0,#bufferbase
		mov lengthascii,#0
		mov dptr,#txtreport
		call sendstr2buff
		call writestate
		call printcrlf
		call printbuffascii
		call writemsg

		jb autosend,renosend
		call sendmsg
		jc $+5
		call sendmsg		;try again
renosend:	jb autodel,$+6
		call delmsg
		setb c
		ret

;---------------
exerestatecmd:	mov dptr,#txtmsgrestate
		call search
		jb flagfind,$+5
restatenotexe:	clr c
		ret

		call delmsg		;del message re state

		cjne a,#bufferbase+10,$+3
		jnc restatenotexe
		dispstrlcd2 txtmsgrequest
		call wrrequest
		jnc restatenotexe
		ret

txtmsgrequest:	db 'Message REQUEST ',0
txtmsgrestate:	db 9,'ctrlstate'
