;--------------------------------------------------------------------
;basic gsm modem response
;memory used:	r1, rxbuffer, tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

waitok:		pollmode
		gsmuartrxpoll 10
		jnc waitokrto
		call rolltmpbuffer
checkok:	cjne a,#'K',waitok+2
		mov a,tmp6
		cjne a,#'O',waitok+2
		setb c			;OK detected
waitokrto:	ret

waitlongok:	pollmode
		gsmuartrxpoll 250
		jnc waitlongokrto
		call rolltmpbuffer
checklongok:	cjne a,#'K',waitlongok+2
		mov a,tmp6
		cjne a,#'O',waitlongok+2
		setb c			;OK detected
waitlongokrto:	ret

wait3digit:	pollmode
		reset3digit
wait3digit1:	gsmuartrxpoll 10
		jnc wait3drto
		cjne a,#13,$+6
		jmp get3digit
		call isdigit
		jnc wait3digit1
		roll3digit
		jmp wait3digit1
get3digit:	setb c
wait3drto:	ret

conv3d2byte:	mov a,tmp2		;convert 3digit ascii to 1 byte hex
		clr c
		subb a,#'0'
		mov tmp2,a
		mov a,tmp0
		clr c
		subb a,#'0'
		mov b,#100
		mul ab
		mov tmp3,a
		mov a,tmp1
		clr c
		subb a,#'0'
		mov b,#10
		mul ab
		add a,tmp3
		add a,tmp2
		ret

uartrxpolling:
uartrxpoll:	clr et1
		clr tr1
		mov th0,#0
		mov tl0,#0
		clr tf0
		jnb tf0,$+8
		djnz r1,$-5
		jmp urxpollerr
		jb rxgsm,$-8
urxpollstart:	mov r2,#10
		nop
		djnz r2,$
		jb rxgsm,urxpollerr
		mov r1,#8
urxpollloop:	mov r2,#21
		nop
		djnz r2,$
		mov c,rxgsm
		rrc a
		djnz r1,urxpollloop
		jnz $+7
		mov a,rxbuffer
		jz rxgsmoff		;no response
		clr a
		mov rxbuffer,a
		setb rxavail
		setb c
		setb et1
		setb tr1
		ret
urxpollerr:	clr rxavail
		clr c
		setb et1
		setb tr1
		ret

rxgsmoff:	mov th0,#0
		mov tl0,#0
		clr tf0
		jnb tf0,$		;check for gsm off?
		jnb rxgsm,urxpollerr
		mov a,#1
		ret

sendchar2gsm:	call delay100ms
uarttx:		push acc
		mov r1,#1+8
		clr c			;start bit
uarttxloop:	mov txgsm,c		;2 c
		mov r2,#20		;1 c
		nop			;1 c
		djnz r2,$		;2x20 c
		rrc a			;1 c
		nop			;1 c
		djnz r1,uarttxloop	;2 c
		nop
		setb txgsm		;stop bit
		mov r2,#0		;22
		nop
		djnz r2,$
		pop acc
		ret

senddec2gsm:	push acc
		mov b,#100
		div ab
		jz decgsmunder100
decgsmup100:	add a,#'0'
		call uarttx
		mov a,b
		mov b,#10
		div ab
decgsmup10:	add a,#'0'
		call uarttx
decgsmunder10:	mov a,b
		add a,#'0'
		call uarttx
		pop acc
		ret
decgsmunder100:	mov a,b
		mov b,#10
		div ab
		jz decgsmunder10
		jmp decgsmup10

gethexgsm:	gsmuartrxpoll 20
		jnc gethexgsmerr
		call ishex
		jnc gethexgsmerr
		call atoh
		swap a
		mov b,a
		gsmuartrxpoll 20
		jnc gethexgsmerr
		call ishex
		jnc gethexgsmerr
		call atoh
		orl a,b
		setb c
gethexgsmerr:	ret

sendhex2gsm:	push acc
		push acc
		swap a
		call htoa
		call uarttx
		pop acc
		call htoa
		call uarttx
		pop acc
		ret

sendstr2gsm:	push acc
		clr a
		movc a,@a+dptr
		jnz $+5
		pop acc
		ret
		call uarttx
		inc dptr
		jmp sendstr2gsm+2


;--------------------------------------------------------------------
;checking gsm connection
;init gsm
;--------------------------------------------------------------------

initgsm:	pollmode
		dispstrlcd1 txtinitgsm
		dispstrlcd2 txtplswait
initgsm1:	sendatcmd txtate1	;activate command echo
		call delay250ms
		sendatcmd txtatq0	;display acknowledgments
		call delay250ms
		sendatcmd txtatv1	;output ack as text
		call delay250ms
		ret

checkgsm:	pollmode
		call initgsm1
		dispstrlcd1 txtcheck
		mov r3,#10
checkgsm1:	sendatcmd txtat
		call waitok
		jnc notconnect
		dispstrlcd2 txtconnected
		ret
notconnect:	dispstrlcd2 txtnotconnect
		call delay05s
		dispstrlcd2 txtblank
		djnz r3,checkgsm1
		ret

selsmsmemory:	dispstrlcd1 txtsms2sim
		sendatcmd txtatcpms
		mov a,#13
		call sendchar2gsm
		call waitok
		jnc cpmserr
		dispstrlcd2 txtcpmsok
		setb c
		ret
cpmserr:	dispstrlcd2 txtcpmserr
		clr c
		ret

txtinitgsm:	db 'Init GSM Modem  ',0
txtplswait:	db 'Please wait...  ',0
txtate1:	db 'ATE1',13,0
txtatq0:	db 'ATQ0',13,0
txtatv1:	db 'ATV1',13,0
txtcheck:	db 'GSM Modem Status',0
txtconnected:	db 'CONNECTED...    ',0
txtnotconnect:	db 'NOT CONNECTED...',0
txtblank:	db '                ',0
txtsms2sim:	db 'Select SMS->SIM ',0
txtcpmsok:	db '+CPMS OK        ',0
txtcpmserr:	db '+CPMS error...  ',0
txtatcpms:	db 'AT+CPMS="SM","SM"',0
txtat:		db 'AT',13,0
