;--------------------------------------------------------------------
;read input and create message if input changing
;memory used:	r4, r5, r6, r7
;--------------------------------------------------------------------

readinstate:	mov a,port0		;read input state
		mov r4,a
		xrl a,inport		;check input changing
		mov inport,r4
		jz readinstate2
		mov r5,#'1'		;input changed
		jmp statechange
readinstate2:	clr c			;no change
		ret

statechange:	mov r6,#0
		rlc a			;find changed input number
		inc r6
		jnc statechange+2
		dispstrlcd1 txtinchanged
		dispstrlcd2 txtblank
		dispstrlcd2 txtchange
		call findchange
		call outstrlcd
		mov dptr,#txtatinput
		call outstrlcd
		mov a,r6
		add a,#'0'
		call outcharlcd
		call wrreinchange		
		call printcrlf
		call printbuffascii
		call delay1s
		setb c
		ret

sendchar2buff:	mov @r0,a
		inc r0
		inc lengthascii
		mov @r0,#0
		ret

buffswaphex:	push acc
		anl a,#0fh		;lower nibble first
		call htoa		;in swap byte
		call sendchar2buff
		pop acc
		anl a,#0f0h		;then higher nibble
		swap a
		call htoa
		call sendchar2buff
		ret

sendstr2buff:	push acc
		clr a
		movc a,@a+dptr
		jnz $+5
		pop acc
		ret
		call sendchar2buff
		inc dptr
		jmp sendstr2buff+2

;---------------
wrreinchange:	mov r0,#bufferbase
		mov lengthascii,#0
		mov dptr,#txtreport
		call sendstr2buff
		mov dptr,#txtchange
		call sendstr2buff
		call findchange
		call sendstr2buff
		mov dptr,#txtatinput
		call sendstr2buff
		mov a,r6
		add a,#'0'
		call sendchar2buff
writestate:	call wrreport1		;write state w/out 'changed'
		mov dptr,#txtlogat
		call sendstr2buff
		push 0
		call readtime
		pop 0
		mov a,hour
		call buffswaphex
		mov a,#':'
		call sendchar2buff
		mov a,minute
		call buffswaphex
		ret

findchange:	push 06
		mov a,inport
		rlc a			;find change high or low
		djnz r6,$-1
		pop 06
		jnc $+6
		mov dptr,#txthigh
		ret
		mov dptr,#txtlow
		ret

wrreport:	mov r0,#bufferbase
		mov lengthascii,#0
		mov dptr,#txtreport
		call sendstr2buff
wrreport1:	mov dptr,#txtinput
		call sendstr2buff
		mov dptr,#txtinre	;write re in1
		call sendstr2buff
		mov a,inport
		call wrswstate
		mov dptr,#txtoutput
		call sendstr2buff
		mov dptr,#txtoutre	;write re out
		call sendstr2buff
		mov a,outport
		call wrswstate
		ret

wrswnibble:	mov r7,#4
		rrc a
		push acc
		jc $+7
		mov a,#'0'
		jmp $+5
		mov a,#'1'
		call sendchar2buff
		pop acc
		djnz r7,wrswnibble+2
		ret

wrswstate:	call wrswnibble
		push acc
		mov a,#'.'
		call sendchar2buff
		pop acc
		call wrswnibble
		ret

txtinchanged:	db 'INPUT CHANGED !!',0
txtchange:	db 'Change ',0
txthigh:	db 'HIGH',0
txtlow:		db 'LOW',0
txtatinput:	db ' IN',0
txtreport:	db 'AutoCTRL Re:',10,0
txtinput:	db 10,'INPUT (1..8):',0
txtinre:	db 10,'> IN=',0
txtoutput:	db 10,'OUTPUT (1..8):',0
txtoutre:	db 10,'> OUT=',0
txtlogat:	db 10,'Log at ',0
