;--------------------------------------------------------------------
;convert ascii to pdu
;memory used:	r4(mask1), r5(mask2), r6(shiftcounter)
;		charbuf, bufferbase++
;--------------------------------------------------------------------

ascii2pdu:	mov r0,#buffbaseascii
		mov r1,#buffbaseascii
ascii2pdu1:	mov r4,#7fh
		mov r5,#80h
		mov r6,#0
		mov a,@r1
		jz exitascii2pdu
ascii2pdu2:	anl a,r4		;mask upper bit byte n
		mov b,a			;save to b reg
		inc r1
		mov a,@r1		;take byte n+1
		jz exitascii2pdu
		inc r6
		mov r7,06
		rr a			;>> [r6]
		djnz r7,$-1
		mov charbuf,a
		anl a,r5		;mask lower bit byte n+1
		orl a,b			;take pdu
		push acc
		mov a,r6
		cjne a,#8,$+12
		mov a,#' '		;count=8 pdu n = ' ' (20h)
		mov @r0,a		;skip 8B ascii=7B byte pdu
		inc r0
		pop acc
		jmp $+7
		pop acc
		mov @r0,a		;pdu n = byte n | byte n+1
		inc r0
		mov a,r4
		clr c
		rrc a			;>> r4
		mov r4,a
		cpl a
		mov r5,a		;r5 = ~r4
		mov a,r6
		cjne a,#8,$+5
		jmp ascii2pdu1
		mov a,charbuf
		jmp ascii2pdu2
exitascii2pdu:	mov a,b
		mov @r0,a
		inc r0
		clr a
		mov @r0,a
		ret


;--------------------------------------------------------------------
;convert pdu to ascii
;memory used:	r4, r5, r6
;		charbuf, lengthascii, bufferbase++
;--------------------------------------------------------------------

pdu2ascii:	push lengthascii
		mov r0,#bufferbase
		mov r1,#bufferbase
pdu2ascii1:	mov r4,#7fh
		mov r5,#01h
		mov r6,#0
		mov a,@r0		;take first pdu
		mov charbuf,a		;save first pdu
		anl a,r4		;mask upper bit
		mov @r1,a		;take first ascii byte
		djnz lengthascii,$+6
		jmp exitpdu2ascii
pdu2ascii2:	inc r6
		mov r7,06
		mov a,charbuf
		rl a			;<< [r6]
		djnz r7,$-1
		anl a,r5
		mov b,a
		inc r0
		mov a,@r0		;take next pdu
		mov charbuf,a		;save pdu n
		mov r7,06
		clr c
		rlc a
		djnz r7,$-2
		anl a,r4
		orl a,b
		inc r1
		mov @r1,a		;take ascii byte
		djnz lengthascii,$+6
		jmp exitpdu2ascii
		mov a,r5
		setb c
		rlc a
		mov r5,a
		mov a,r6
		cjne a,#6,pdu2ascii2
		mov a,charbuf
		rr a
		anl a,r4
		inc r1
		mov @r1,a		;take ascii byte /8
		djnz lengthascii,$+6
		jmp exitpdu2ascii
		inc r0			;skip 1B @pdu buff (20h)
		inc r0
		inc r1
		jmp pdu2ascii1
exitpdu2ascii:	inc r1
		clr a
		mov @r1,a
		pop lengthascii
		ret